local mapMod = foundation.createMod();

mapMod:registerAssetId("maps/MapCoastJ.png", "HEIGHT_MAP")
mapMod:registerAssetId("maps/material_mask_c.png", "MATERIAL_MASK")
mapMod:registerAssetId("maps/coniferous_density.png", "CONIFEROUS_DENSITY_MAP")
mapMod:registerAssetId("maps/deciduous_density.png", "DECIDUOUS_DENSITY_MAP")
mapMod:registerAssetId("maps/berries_density.png", "BERRIES_DENSITY_MAP")
mapMod:registerAssetId("maps/rock_density.png", "ROCK_DENSITY_MAP")
mapMod:registerAssetId("maps/fish_density.png", "FISH_DENSITY_MAP")

-- Register Custom Map
mapMod:register({
	DataType = "CUSTOM_MAP",
	Id = "MAP_RhacotisRockCliffs_2019_1",
	HeightMap = "HEIGHT_MAP",
	MaterialMask = "MATERIAL_MASK",
	MinHeight = -32,
	MaxHeight = 90,
	VillagePathList = {
		{
			Entrance = { 1012, 0, 411 },
			Exit = { 1012, 0, 411 }
		},
		{
			Entrance = { 12, 0, 930 },
			Exit = { 12, 0, 930 }
		},
		{
			Entrance = { 900, 0, 1012 },
			Exit = { 900, 0, 1012 }
		},
		{
			Entrance = { 640, 0, 1012 },
			Exit = { 640, 0, 1012 }
		},
		{
			Entrance = { 12, 0, 900 },
			Exit = { 12, 0, 900 }
		},
		{
			Entrance = { 4, 0, 985 },
			Exit = { 1012, 0, 135 }
		}
	},
	SpawnList = {
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 370, 9, 367 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 240, 12, 620 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 750, 12, 490 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 732, 10, 492 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 890, 10, 270 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 64, 3, 700 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},

		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 370, 8, 450 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},

		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 860, 10, 515 },
			Orientation = { 0.0, 0.1, 0.0 }
		},

		--Mountain small
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 465, 23, 711 },
			Orientation = { 0.0, math.randomf(4.0, 4.2), 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 468, 21, 698 },
			Orientation = { 0.0, 3.3, 0.0 }
		},

		--Mountain
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 600, 37, 780 },
			Orientation = { 0.0, 3.1, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 588, 36, 782 },
			Orientation = { 0.0, 3.3, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 595, 41, 785 },
			Orientation = { 0.0, math.randomf(-180, 180), 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 566, 35, 781 },
			Orientation = { 0.0, math.randomf(2.9, 3.3), 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 615, 38, 761 },
			Orientation = { 0.0, 4.1, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 616, 37, 748 },
			Orientation = { 0.0, 4.0, 0.0 }
		},

		--water
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 975, -6, 125 },
			Orientation = { 0.0, math.randomf(2.9, 3.3), 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 555, -8, 124 },
			Orientation = { 0.0, math.randomf(2.9, 3.3), 0.0 }
		},

		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 120, 5, 425 },
			Orientation = { 0.0, 1.1, 0.0 }
		},

		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 856, 20, 191 },
			Orientation = { 0.0, -0.1, 0.0 }
		},

		--River
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 270, 3, 511 },
			Orientation = { 0.0, math.randomf(-3.9, 3.3), 0.0 }
		},


		-- Island
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 260, 3, 170 },
			Orientation = { 0.0, -0.1, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 252, 6, 167 },
			Orientation = { 0.0, math.randomf(3.1,3.4), 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 245, 2, 172 },
			Orientation = { 0.0, math.randomf(-0.2,-0.4), 0.0 }
		},

		-- Coast small
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 380, 10, 257 },
			Orientation = { 0.0, 3.1, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 390, 11, 246 },
			Orientation = { 0.0, 3.2, 0.0 }
		},

		-- Coast
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 505, 4, 188 },
			Orientation = { 0.0, 0.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 480, 3, 190 },
			Orientation = { 0.0, 0.0, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 475, 4, 209 },
			Orientation = { 0.0, -0.5, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 479, 9, 202 },
			Orientation = { 0.0, math.randomf(-1, 1), 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 485, 5, 205 },
			Orientation = { 0.0, 0.1, 0.0 }
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 470, 3, 202 },
			Orientation = { 0.0, 3.0, 0.0 }
		}

	},
	DensitySpawnList = {
		{
			-- Create forest of Deciduous trees and a few pine
			DensityMap = "DECIDUOUS_DENSITY_MAP",
			Density = 0.90,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_TREE_POPLAR" },
					RandomWeight = 8,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				},
				{
					PrefabList = { "PREFAB_TREE_OAK" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.9,
						Max = 1.9
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.9,
						Max = 1.9
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				},
				{
					PrefabList = { "PREFAB_TREE_SYCAMORE" },
					RandomWeight = 8,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				},
				{
					PrefabList = { "PREFAB_TREE_PINE" },
					RandomWeight = 1,
					OffsetSizeRange = {
						Min = 0.15,
						Max = 0.45
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.7,
						Max = 1
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
			{
			-- Create forest of Pine Trees
			DensityMap = "CONIFEROUS_DENSITY_MAP",
			Density = 0.85,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_TREE_PINE" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create forest of berry bushes
			DensityMap = "BERRIES_DENSITY_MAP",
			Density = 1,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_RESOURCE_BERRIES" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create rock outcrops - stone resource
			DensityMap = "ROCK_DENSITY_MAP",
			Density = 1,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_RESOURCE_ROCK" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create fish shoals
			DensityMap = "FISH_DENSITY_MAP",
			Density = 1,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_RESOURCE_FISH" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		}
	}
})